package com.sksamuel.jmxc

import scala.collection.JavaConverters._
import javax.management.remote.{JMXServiceURL, JMXConnector, JMXConnectorFactory}
import javax.management.{ObjectName, Query, MBeanServerConnection}

/** @author Stephen Samuel
  *
  *         A connection client to a JMX server.
  *
  **/
class JmxClient(conn: MBeanServerConnection) {

    // returns a count of all mbeans
    def count: Int = conn.getMBeanCount
    def domains: Array[JmxDomain] = conn.getDomains.map(new JmxDomain(_, conn)).toArray
    def domain(name: String): Option[JmxDomain] = domains.find(_.name == name)
}
