package com.sksamuel.jmxc

import sun.jvmstat.monitor._
import scala.Some
import sun.management.ConnectorAddressLink
import scala.collection.JavaConverters._

/** @author Stephen Samuel */
object JmxClientFactorySupport {

    /**
     * Returns the process ids of all local vms
     *
     * @return
     */
    def localVmPids: Seq[Int] = {
        val host = MonitoredHost.getMonitoredHost(null.asInstanceOf[String])
        host.activeVms().asScala.map(_.toInt).toList
    }

    def localVms: Seq[LocalVm] = {
        val host = MonitoredHost.getMonitoredHost(null.asInstanceOf[String])
        host.activeVms().asScala.map(pid => {
            val mvm = host.getMonitoredVm(new VmIdentifier(pid.toString))
            val name = MonitoredVmUtil.commandLine(mvm)
            val attachable = MonitoredVmUtil.isAttachable(mvm)
            val address = ConnectorAddressLink.importFrom(pid)
            mvm.detach()
            LocalVm(name, attachable, address, pid)
        }).toList
    }

    def localAttachables: Seq[LocalVm] = localVms.filter(arg => arg.attachable && arg.address != null)

    case class LocalVm(name: String, attachable: Boolean, address: String, pid: Int)
}


